/**
 *
 */
package cn.citycraft.SimpleEssential;

import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.event.Listener;
import org.bukkit.plugin.java.JavaPlugin;

import cn.citycraft.PluginHelper.commands.HandlerMainCommand;
import cn.citycraft.PluginHelper.config.FileConfig;
import cn.citycraft.PluginHelper.utils.VersionChecker;
import cn.citycraft.SimpleEssential.command.CommandBack;
import cn.citycraft.SimpleEssential.command.CommandEnchantBench;
import cn.citycraft.SimpleEssential.command.CommandGc;
import cn.citycraft.SimpleEssential.command.CommandHat;
import cn.citycraft.SimpleEssential.command.CommandHome;
import cn.citycraft.SimpleEssential.command.CommandPing;
import cn.citycraft.SimpleEssential.command.CommandSetHome;
import cn.citycraft.SimpleEssential.command.CommandSetSpawn;
import cn.citycraft.SimpleEssential.command.CommandSpawn;
import cn.citycraft.SimpleEssential.command.CommandSuicide;
import cn.citycraft.SimpleEssential.command.CommandTop;
import cn.citycraft.SimpleEssential.command.CommandTpa;
import cn.citycraft.SimpleEssential.command.CommandTpaccept;
import cn.citycraft.SimpleEssential.command.CommandTpdeny;
import cn.citycraft.SimpleEssential.command.CommandTphere;
import cn.citycraft.SimpleEssential.command.CommandWorkBench;
import cn.citycraft.SimpleEssential.command.CommandWorld;
import cn.citycraft.SimpleEssential.config.I18n;
import cn.citycraft.SimpleEssential.listen.PlayerLocationListen;
import cn.citycraft.SimpleEssential.teleport.TeleportControl;

/**
 * 简单基础插件
 *
 * @author 蒋天蓓 2015年8月11日下午3:29:32
 */
public class SimpleEssential extends JavaPlugin {
	/**
	 * 传送控制
	 */
	public TeleportControl tpcontrol;

	/**
	 * 命令监听列表
	 */
	FileConfig config;

	/**
	 * 命令处理
	 */
	HandlerMainCommand hmc;

	@Override
	public boolean onCommand(final CommandSender sender, final Command cmd, final String label, final String[] args) {
		if (!hmc.onCommand(sender, cmd, label, args)) {
			hmc.sendHelp(sender);
		}
		return true;
	}

	@Override
	public void onEnable() {
		this.initTeleportControl();
		this.registerEvents();
		this.registerCommands();
		new VersionChecker(this);
	}

	@Override
	public void onLoad() {
		config = new FileConfig(this);
		I18n.load(this);
	}

	/**
	 * 注册插件主要命令
	 */
	public void registerCommands() {
		hmc = new HandlerMainCommand(this);
		hmc.registerCommand(new CommandTpa(this));
		hmc.registerCommand(new CommandTop(this));
		hmc.registerCommand(new CommandTpaccept(this));
		hmc.registerCommand(new CommandTpdeny(this));
		hmc.registerCommand(new CommandTphere(this));
		hmc.registerCommand(new CommandBack(this));
		hmc.registerCommand(new CommandSetHome(this));
		hmc.registerCommand(new CommandHome(this));
		hmc.registerCommand(new CommandHat(this));
		hmc.registerCommand(new CommandSuicide(this));
		hmc.registerCommand(new CommandEnchantBench(this));
		hmc.registerCommand(new CommandWorkBench(this));
		hmc.registerCommand(new CommandSetSpawn(this));
		hmc.registerCommand(new CommandSpawn(this));
		hmc.registerCommand(new CommandGc(this));
		hmc.registerCommand(new CommandWorld(this));
		hmc.registerCommand(new CommandPing(this));
	}

	/**
	 * 注册事件
	 *
	 * @param listener
	 *            - 被注册的事件类
	 */
	public void registerEvent(final Listener listener) {
		getServer().getPluginManager().registerEvents(listener, this);
	}

	private void initTeleportControl() {
		final int tpdelay = config.getInt("Teleport.delay", 3);
		final String tpcontorlname = config.getMessage("Teleport.name");
		tpcontrol = new TeleportControl(this, tpcontorlname, tpdelay);
	}

	/**
	 * 注册事件
	 */
	private void registerEvents() {
		registerEvent(new PlayerLocationListen(this));
	}
}
