package cn.citycraft.SimpleEssential.command;

import java.util.Arrays;
import java.util.List;

import org.bukkit.Bukkit;
import org.bukkit.Effect;
import org.bukkit.command.Command;
import org.bukkit.command.CommandException;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.inventory.ItemStack;

import cn.citycraft.PluginHelper.commands.BaseCommand;
import cn.citycraft.SimpleEssential.SimpleEssential;
import cn.citycraft.SimpleEssential.config.I18n;
import cn.citycraft.SimpleEssential.utils.EffectUtil;

/**
 * 自杀命令
 *
 * @Author 代小呆 created in 2015年8月14日下午4:24:19
 */

public class CommandSuicide extends BaseCommand {
	private final SimpleEssential plugin;

	public CommandSuicide(final SimpleEssential main) {
		super("suicide", "sesuicide", "sd");
		this.plugin = main;
		setOnlyPlayerExecutable();
		setDescription("自杀");
	}

	@Override
	public void execute(final CommandSender sender, final Command command, final String label, final String[] args) throws CommandException {
		final Player p = (Player) sender;
		final List<ItemStack> drops = Arrays.asList(p.getInventory().getContents());
		final int deoppedexp = (int) Math.floor(p.getExp());
		final String deathMessage = I18n.p("Suicide.msg");
		final PlayerDeathEvent pd = new PlayerDeathEvent(p, drops, deoppedexp, deathMessage);
		plugin.getServer().getPluginManager().callEvent(pd);
		Bukkit.broadcastMessage(pd.getDeathMessage());
		EffectUtil.run(p.getLocation(), 10, Effect.POTION_BREAK);
		p.setHealth(0);
	}
}
